<template>
  <div id="app">
    <div class="js-terminal"></div>
  </div>
</template>

<script>
import $ from 'jquery'
import 'jquery.terminal'
import io from 'socket.io-client';

const socket = io('http://127.0.0.1:8080/terminal-command');

let terminal = null
let credential_callback = null

$(() => {
  setTimeout(() => {
    terminal = $('.js-terminal').terminal(function(command) {
      if (command !== '') {
        if (command.trim().indexOf('goto') == 0) {
          window.location.href = '/' + command.substring(4, command.length).trim()
        } else {
          socket.emit('command', {
            type: 'execution',
            package: {
              command: command
            }
          })
        }
      }
    }, {
      greetings: 'Welcome to Steve\'s Terminal',
      name: 'steve_terminal',
      prompt: 'steve@server> ',
      login: function(user, password, callback) {
        credential_callback = callback
        socket.emit('command', {
          type: 'authentication',
          package: {
            user: user,
            password: password
          }
        })
      }
    })

    socket.on('connect', () => {})
    socket.on('response', (data) => {
      if (terminal != null) {
        switch (data.from) {
          case 'authentication':
            if (data.result.allow == true)
              credential_callback(data.result.auth_token)
            else
              credential_callback(null)
            break;
          case 'execution':
            if (data.result.status == true)
                terminal.echo(data.result.output)
            break;
          default:
            break;
        }
      }
    })
    socket.on('disconnect', () => {})

  })
})

export default {
  name: 'terminal'
}
</script>

<style lang="scss">
body {
  background: #000;
  height: 100vh;
  margin: 0;
}

.js-terminal {
  height: 100%;
}

#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: left;
  color: #2c3e50;
  margin: 0;
  width: 100%;
}
</style>
